services:
  database:
    image: postgres:latest
    environment:
      POSTGRES_USER: bgd
      POSTGRES_PASSWORD: insecure
      POSTGRES_DB: bgd
    volumes:
      - type: volume
        source: db
        target: /var/lib/postgresql/data
    networks:
      - backend
    ports:
      - "5432:5432"

  buildgrid:
    image: registry.gitlab.com/buildgrid/buildgrid/buildgrid:latest
    # This entrypoint delays the start of BuildGrid hopefully long enough
    # for the PostgreSQL container to start up.
    entrypoint: "/bin/bash"
    command:
      - "-c"
      - "sleep 5 && /app/env/bin/bgd server start -vvv /app/data/config/run-userchroot-bgdconf.yml"
    volumes:
      - type: bind
        source: ./run-userchroot-bgdconf.yml
        target: /app/data/config/run-userchroot-bgdconf.yml
      - type: volume
        source: data
        target: /var/lib/buildgrid/store
        volume:
          nocopy: true
    ports:
      - "50051:50051"
    networks:
      - backend
      - host

  bots: # To be scaled horizontaly
    build:
      dockerfile: Dockerfile.run-userchroot
      context: .
    image: buildbox-run-userchroot:local
    environment:
      BUILDGRID_SERVER_URL: http://buildgrid:50051
      CAS_SERVER_URL: http://buildgrid:50051
      BUILDBOX_STAGER: hardlink
      # Ugly way to inject extra options into the worker command line
      # TODO: remove when the worker image supports this cleanly
      PLATFORM_PROPERTY_OPTS: --runner-arg=--inject-path=/testing/known-path:/home/test-file-injection --runner-arg=--inject-path=/testing/mapped-directory:/home/directory
    privileged: true
    volumes:
      - type: volume
        source: cache
        target: /var/lib/buildgrid/cache
    depends_on:
      - buildgrid
    networks:
      - backend
    restart: on-failure

networks:
  backend:
  host:

volumes:
  cache:
  data:
  db:
